function main = gen(i)

% function main = gen(i)
% generates datasets for given parameter sets
% parameters are set in the table, so don't change these to much
% if you do, the old file will be over-written
% Also, the real values are written at the head of the file
% the table is organized as follows:
%
% table = { {Cnum, Knum, BCnum, solvemeth , tstep, xmax , xstep, errorvector}}
% errorvec = [randp,systp,randq,systq];
% and the data is written to the file names p<i>.dat
% and numeric solution to p<i>sol.mat

%-----------------------------------
special = {
{13, 16, 12 , 'ode15s' , 201 , 5 , 51, [0,0,0,0]}
};
% 4 works
table = { 
{10, 10, 5 , 'ode15s' , 1001 , 3 , 51, [0,0,0,0]},
{10, 10, 6 , 'ode15s' , 1001 , 3 , 51, [0,0,0,0]},
{6, 7 , 4 , 'ode15s' , 1001 , 3 , 51, [0,0,0,0]},
{6, 7, 4 , 'ode15s' , 151 , 3 , 51, [0,0,0,0]}
{11, 13, 9 , 'ode15s' , 151 , 3 , 51, [0,0,0,0]}
{12, 14, 9 , 'ode15s' , 151 , 3 , 51, [0,0,0,0]}
{12, 14, 10 , 'ode15s' , 151 , 3 , 51, [0,0,0,0]}
{2, 3, 1 , 'ode15s' , 1001 , 2 , 51, [0,0,0,0]}
{2, 5, 1 , 'ode15s' , 1001 , 2 , 51, [0,0,0,0]}
{3, 3, 1 , 'ode15s' , 1001 , 2 , 51, [0,0,0,0]}
{3, 5, 1 , 'ode15s' , 1001 , 2 , 51, [0,0,0,0]}

};

%-------------------------------------
% make data

if i == 999 
  table{999} = special{1};
end

[x,t,u,g,h,C0,K0,BC0,BC1]=exper(table{i});

%-------------------------------------
% write data to file

fname = sprintf('p%i',i);
fid = fopen(strcat(fname,'.dat'),'w');
fprintf(fid,'%% Generated on %s \n',date);
fprintf(fid,'%% using table entry %i \n \n',i);
fprintf(fid,'%% C{%i} = %s \n',table{i}{1},C('x',table{i}{1}));
fprintf(fid,'%% K{%i} = %s \n',table{i}{2},K('x',table{i}{2}));
fprintf(fid,'%% BC{%i} = ',table{i}{3});
fprintf(fid,'%i ',BC(table{i}{3}));
fprintf(fid,'\n');
fprintf(fid,'%% full table entry = {%i,%i,%i,%s,%i,%i,%i,[%i,%i,%i,%i]}\n',table{i}{:});

fprintf(fid,'%%  \n');
fprintf(fid,'%%  \n');

fprintf(fid,'%% First row first entry contains C0 \n');
fprintf(fid,'%% Second row first entry contains K0 \n');
fprintf(fid,'%% First row last entry contains min(x) \n');
fprintf(fid,'%% Second row last entry contains max(x) \n');

fprintf(fid,'%%  \n');
fprintf(fid,'%%  \n');

fprintf(fid,'%12.10f %8.2f %8.2f %10.6f %10.6f\n',C0,NaN,NaN,NaN,min(x));
fprintf(fid,'%12.10f %8.2f %8.2f %10.6f %10.6f\n',K0,NaN,NaN,NaN,max(x));
fprintf(fid,'%%  \n');

fprintf(fid,'%% %12s %8s %8s %10s %10s','time','BC0','BC1','mstate0','mflux1'); 
fprintf(fid,'\n');
fprintf(fid,'%%  \n');
for j = 1:length(t) 
  fprintf(fid,'%12.10f %8.2f %8.2f %10.6f %10.6f\n',t(j),BC0(j),BC1(j),g(j),h(j)); 
end
fclose(fid);

save(strcat(fname,'sol.mat'),'x','t','u');  
%--------------------------------------

